<?php
namespace Pedidos\Logic\Util;

class ExcelUtils
{
	private $xls;
	private $columnMaxBound;
	private $rowMaxBound;

	public function __construct($xlsFilePath) 
	{
        $xls       = \PHPExcel_IOFactory::createReaderForFile($xlsFilePath);

		$xlsReader = $xls->load($xlsFilePath);
		$this->xls = $xlsReader->getActiveSheet();

		$this->columnMaxBound = \PHPExcel_Cell::columnIndexFromString($this->xls->getHighestColumn());
		$this->rowMaxBound    = $this->xls->getHighestRow();
	}

	public function buildDataIntoJson()
	{
		return $this->getData();
	}

	public function buildDataCamposIntoJson()
	{
		return $this->getDataCampos();
	}

	private function getCampos(){
		$campos = array();
		for ($i = 0; $i < 3; $i++) {
			$j = $i+5;
			$cell = $this->xls->getCellByColumnAndRow(0, $j);
			$campos[] = $cell->getValue();
			$j++;
		}

		return $campos;
	}

	private function getDataCampos(){
		$campos = $this->getCampos();
		$data = array();

		$j=0;
		foreach ($campos as $key => $value) {
			$cell = $this->xls->getCellByColumnAndRow(1, $j+5);
			$data[0][$value] = $cell->getFormattedValue();
			$j++;
        }

        return $data;
	}
	
	private function getHeaders()
	{
		$headers = array();
		for ($i = 0; $i < $this->columnMaxBound; $i++) {
			$cell = $this->xls->getCellByColumnAndRow($i, 10);
			$headers[] = $cell->getValue();
		}

		return $headers;
	}

	private function getData()
	{
		$headers = $this->getHeaders();
		$data    = array();
        // A primeira linha a ser percorrida deve ser a primeira contendo dados (a linha 1 contem os cabecalhos dos dados).
        for ($i = 11; $i <= $this->rowMaxBound; $i++) {
            foreach ($headers as $key => $value) {
				$cell = $this->xls->getCellByColumnAndRow($key, $i);
				$data[$i][$value] = $cell->getFormattedValue();
            }
        }

		return $data;
	}
}