/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: CRIA_LISTA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/*    26/08/2004 - Joo Fernando dos Reis Corra                              */
/*                                                                            */
/******************************************************************************/


IF EXISTS (SELECT * FROM sysobjects O, sysusers U
            WHERE
            o.name = 'CRIA_LISTA'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
   DROP PROCEDURE CRIA_LISTA;
GO

CREATE PROCEDURE CRIA_LISTA(
   @P_CDFILIAL   VARCHAR(4),
   @P_NRSEQPRELIST VARCHAR(10),
   @P_ROWSAFFECT DOUBLE PRECISION OUTPUT) AS

DECLARE @V_ITMPREVLIST_CDFILIAL VARCHAR(4);
DECLARE @V_ITMPREVLIST_NRCOLEPRECO VARCHAR(10);
DECLARE @V_ITMPREVLIST_CDFORNECED VARCHAR(21);
DECLARE @V_ITMPREVLIST_CDREGIAO VARCHAR(3);
DECLARE @V_ITMPREVLIST_CDPRODUTO VARCHAR(10);
DECLARE @V_ITMPREVLIST_CDMARCA VARCHAR(5);
DECLARE @V_CONT_COMMIT DOUBLE PRECISION;
DECLARE @V_QTDE_COMMIT DOUBLE PRECISION;

BEGIN
   SET @V_CONT_COMMIT = 0;
   SET @V_QTDE_COMMIT = 1000;

   DECLARE C_ITMPREVLIST CURSOR FOR  --Declarao do cursor
      SELECT
          ITMPREVLIST.CDFILIAL,
          ITMPREVLIST.NRCOLEPRECO,
          ITMPREVLIST.CDFORNECED,
          ITMPREVLIST.CDREGIAO,
          ITMPREVLIST.CDPRODUTO,
          ITMPREVLIST.CDMARCA
       FROM
          ITMPREVLIST
       WHERE
          ITMPREVLIST.CDFILIAL     = @P_CDFILIAL     AND
          ITMPREVLIST.NRSEQPRELIST = @P_NRSEQPRELIST AND
          ITMPREVLIST.IDITMLISTJAMONT = 'N'
   OPEN C_ITMPREVLIST;
   FETCH NEXT FROM C_ITMPREVLIST INTO @V_ITMPREVLIST_CDFILIAL, @V_ITMPREVLIST_NRCOLEPRECO,
                                      @V_ITMPREVLIST_CDFORNECED, @V_ITMPREVLIST_CDREGIAO,
                                      @V_ITMPREVLIST_CDPRODUTO, @V_ITMPREVLIST_CDMARCA
   WHILE (@@FETCH_STATUS = 0)  BEGIN
      UPDATE
         ITEMCOLE
      SET
         IDITMLISPREC = 'S',
         IDPRECALT    = 'N',
         NRSEQPRELIST = @P_NRSEQPRELIST
      WHERE
         ITEMCOLE.CDFILIAL    = @V_ITMPREVLIST_CDFILIAL    AND
         ITEMCOLE.NRCOLEPRECO = @V_ITMPREVLIST_NRCOLEPRECO AND
         ITEMCOLE.CDFORNECED  = @V_ITMPREVLIST_CDFORNECED  AND
         ITEMCOLE.CDREGIAO    = @V_ITMPREVLIST_CDREGIAO    AND
         ITEMCOLE.CDPRODUTO   = @V_ITMPREVLIST_CDPRODUTO   AND
         ITEMCOLE.CDMARCA     = @V_ITMPREVLIST_CDMARCA;
      UPDATE
         ITMPREVLIST
      SET
         IDITMLISTJAMONT = 'S'
      WHERE ITMPREVLIST.NRSEQPRELIST = @P_NRSEQPRELIST
        AND ITMPREVLIST.CDFILIAL     = @V_ITMPREVLIST_CDFILIAL
        AND ITMPREVLIST.NRCOLEPRECO  = @V_ITMPREVLIST_NRCOLEPRECO
        AND ITMPREVLIST.CDFORNECED   = @V_ITMPREVLIST_CDFORNECED
        AND ITMPREVLIST.CDREGIAO     = @V_ITMPREVLIST_CDREGIAO
        AND ITMPREVLIST.CDPRODUTO    = @V_ITMPREVLIST_CDPRODUTO
        AND ITMPREVLIST.CDMARCA      = @V_ITMPREVLIST_CDMARCA;

      SET @V_CONT_COMMIT = @V_CONT_COMMIT + 1;
      IF (@V_CONT_COMMIT >= @V_QTDE_COMMIT) BEGIN
         BREAK;
      END;

      FETCH NEXT FROM C_ITMPREVLIST INTO @V_ITMPREVLIST_CDFILIAL, @V_ITMPREVLIST_NRCOLEPRECO,
                                         @V_ITMPREVLIST_CDFORNECED, @V_ITMPREVLIST_CDREGIAO,
                                         @V_ITMPREVLIST_CDPRODUTO, @V_ITMPREVLIST_CDMARCA
   END;
   SET @P_ROWSAFFECT = @V_CONT_COMMIT;
   CLOSE C_ITMPREVLIST;
   DEALLOCATE C_ITMPREVLIST;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CRIA_LISTA','5.05.003';
GO

